#include <unistd.h>
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <stdlib.h>
#include <ctype.h>
#include "calc_synt.h"
#include "curses.h"

#include "host.c"

#undef ECHO

#define CD      1
#define PWD     2
#define ECHO    3
#define SET     4
#define UNSET   5
#define EXIT    6
#define DATE	7
#define OTHER   8
#define PATH    10
#define HOME    11
#define STATUS  12
#define AT      13
#define ASSHOLE      14
#define EXPORT	15
#define HOST	16

extern char** environ;
static bool ASSIGN;

#define MAX_LENGTH_COMMAND 80
#define MAX_LENGTH_PATH 80
#define MAX_LENGTH_ARGS 48
#define MAX_ARGS 20

int
parse_cmd(char *command, char *path, char args[MAX_ARGS][MAX_LENGTH_ARGS],
	  int *num_args) 
{
    int i, k = 0, j = 0;
    char stroka[MAX_LENGTH_ARGS];
    for (i = 0; i <= strlen(command); i++)
	 {
	if ((k == 0)
	    && ((command[i] != ' ') && (command[i] != '\n')
		&& (command[i] != '\t'))) {
	    path[j] = command[i];
	    j++;
	} else if ((k == 0)
		   && ((command[i] == ' ') || (command[i] == '\n')
		       || (command[i] == '\t'))) {
	    path[j] = '\0';
	    j = 0;
	    k = 1;
	};
	if ((k != 0) && (command[i] != ' ') && (command[i] != '\n')
	      && (command[i] != '\t')) {
	    args[k - 1][j] /*stroka[j] */  = command[i];
	    j++;
	} else if ((k != 0)
		   && ((command[i] == ' ') || (command[i] == '\n')
		       || (command[i] == '\t'))) {
	    args[k - 1][j] = '\0';
	    j = 0;
	    k++;
	};
	}
    *num_args = k - 2;
    /*  */
    if( *path=='$' ) path=(char*)strdup(FindVar(path+1)->cval);
    
    if (strcmp(path, "cd") == 0)
	return CD;
    if (strcmp(path, "pwd") == 0)
	return PWD;
    if (strcmp(path, "echo") == 0)
	return ECHO;
    if (strcmp(path, "set") == 0)
	{ ASSIGN=true; return AT;}
    if (strcmp(path, "unset") == 0)
	return UNSET;
    if (strcmp(path, "exit") == 0)
	return EXIT;
    if (strcmp(path, "date") == 0)
	return DATE;
    if (strcmp(path, "@") == 0)
	{ ASSIGN=false; return AT;}
    if (strcmp(path, "export") == 0)
	return EXPORT;
    if (strcmp(path, "host") == 0)
	return HOST;	
    return OTHER;
}

typedef struct  {
    char name[31];
    char meaning[255];
} spisok;


spisok vars[255];

char last_var = 2;
int end = 0;
char comanda[MAX_LENGTH_COMMAND];
char prompt[MAX_LENGTH_COMMAND];
int PR = 1;
int len_com = 0;
int com = 0;
int number_args;
char path_com[MAX_LENGTH_PATH], args_com[MAX_ARGS][MAX_LENGTH_ARGS];
char arithm_str[256];
int pid;
int bb;
char *srch_var;

int is_str_up(char *string) 
{
    int flag = 1, i;
    for (i = 0; i <= strlen(string) - 1; i++)
	if (isupper(string[i]) == 0) {
	    flag = 0;
	    break;
	}
    if (flag == 1)
	return 0;
    else
	return 1;
}

int is_str_dig(char *string) 
{
    int flag = 1, i;
    for (i = 0; i <= strlen(string) - 1; i++)
	if (isdigit(string[i]) == 0) {
	    flag = 0;
	    break;
	}
    if (flag == 1)
	return 0;
    else
	return 1;
}

///++++++++++++++++++++++++++++++++++++++++++++++++
void read_comanda(char *line) 
{
    int s;
    int y0, x0, y, x, i = 0;
    for (i = 0; i <= MAX_LENGTH_COMMAND; i++)
	line[i] = 0;
    i = 0;
    
    do
	 {
	s = getchar();
	switch (s)
	     {
	case 8:
	    {
		i--;
		break;
	    }
	case 10:
	    {
		s = 0;
		line[i] = '\n';
		break;
	    }
	    
		//Ctrl-D
	case -1:
	case 4:
	    {
		exit(0);
	    }
	default:
	    line[i++] = s;
	    }
	}
    while (s != 0);
}

/*        */
void sigCHILD(int s){  waitpid(pid,NULL,WNOHANG); }
///++++++++++++++++++++++++++++++++++++++++++++++++++++
typedef struct tm tm_my;

int main(int argc, char **argv)
{
    const char *name = "kurs";
    const char *author = "Lida";
    var_list * l;
    sigset_t cldset; // 
    
    setbuf(stdout, NULL);	//otmena buferizacii
    AddVar("home", (char *) getenv("HOME"));
    AddVar("path", (char *) getenv("PATH"));
    AddVar("status", "0");

 char gdir[512]; /* . 40 */
 char* s;
     if( argv[0][0]=='.' && argv[0][1]=='/' )  getcwd(gdir,512), argv[0]++;
     else gdir[0]='\0';
 
     strncat(gdir,argv[0],512);
     AddVar("shell",gdir);

     if( ! getenv("SHELL") ) setenv("SHELL",gdir,1);

     if( ! ( s=(char*)getenv("SHLVL") ) ) setenv("SHLVL","1",1);
     else 
     {
     char buf[5];
        sprintf(buf,"%i",atoi(s)+1);
        setenv("SHLVL",buf,1);
     }

    
    sigemptyset(&cldset); //  SIGTTOU
    sigaddset(&cldset,SIGTTOU); // 
    sigprocmask(SIG_BLOCK,&cldset,0); // 

    signal(SIGINT,SIG_IGN);
    signal(SIGCHLD,sigCHILD);
    
//    char* dir_nm = get_current_dir_name();
	while (end == 0)
	 {
	int i;
	char temp[MAX_LENGTH_COMMAND];
	char key;
	printf("lidash> ");
	read_comanda(comanda);
	com = parse_cmd(comanda, path_com, args_com, &number_args);
	switch (com) {
	case CD:
	    {
		if (number_args != 1)
//		    printf("%s:Error in cd\n", argv[0]);
		chdir(FindVar("home")->cval);
		
		else if (chdir(args_com[1]) != 0)
		    printf("%s:Cannot change %s dir\n", argv[0],
			   args_com[1]);
		break;
	    }
	case DATE:
	    {
	    time_t t;
		 time(&t); printf("%s",ctime(&t));
		break;
	    }
	case PWD:
	    {
		if (number_args != 0)
		    printf("%s:Error in pwd\n", argv[0]);
		
		else {
		    char c_dir_n[512];
		    int n_l=512;
		    getcwd(c_dir_n, n_l);
		    printf("%s\n", c_dir_n);
		}
		break;
	    }
	case HOST:
	    {
		    char *argv_[MAX_ARGS];
		    for (i = 1; i <= number_args; i++)	//formiruet argv_
		    {
			argv_[i] = (char *) malloc(strlen(args_com[i]));
			strcpy(argv_[i], args_com[i]);
		    }
		    argv_[0] = (char *) malloc(strlen(path_com));
		    strcpy(argv_[0], path_com);
		    argv_[number_args + 1] = NULL;
	    
		host(number_args+1,argv_);
		break;
	    }
	case EXPORT:
	    {
	    int i;
	       /*  /  */
	       if(number_args > 0) for(i=1; i<=number_args; i++)
		setenv(args_com[i],(char*)strdup(FindVar(args_com[i])->cval),1);
	       else for(i=0; environ[i]; i++) printf("%s\n",environ[i]);
            break;
	    }
	case SET:
	    {
		int i;
		char *name;
		char *meaning;
		int flag = 0;
		if (number_args < 1) {
		    PrintVars();
		} else {
		    for (i = 0; i <= strlen(args_com[1]); i++)
			 {
			if ((flag == 0) && (args_com[1][i] != '='))
			    name[i] = args_com[1][i];
			else if (args_com[1][i] == '=') {
			    flag = 1;
			    name[i] = '\0';
			}
			if ((flag == 1) && (args_com[1][i] != '='))
			    meaning[i - strlen(name) - 1] = args_com[1][i];
			}
		    meaning[i - strlen(name)] = '\0';
		    for (i = 2; i <= number_args; i++)
			 {
			strcat(meaning, " ");
			strcat(meaning, args_com[i]);
			}
		    
			//----------------------
			//printf("%s !!!  %s-----%s",args_com[1],name,meaning);
			if (is_str_up(name) == 0) {
			setenv(name, meaning, 1);
		    }
		    
		    else {
			l = FindVar(name);
			if (l != NULL) {
			    strcpy(l->cval, meaning);
			    break;
			}
			
			else
			    AddVar(name, meaning);
		    }
		}		
		    break;
	    }
	case UNSET:
	    {
		int i;
		if (number_args > 0)
		    DelVar(&args_com[1][0]);
		break;
	    }
	case ECHO:
	    {
		int i, j;
		char* s;
		for (i = 1; i <= number_args; i++)
		     {
		    if (args_com[i][0] == '$')
			{
			l = FindVar(&args_com[i][1]);
			if (l == NULL) {
			    s = getenv(args_com[i]+1);
			    if( !s ) cout << "couldnt find that var";
			    else cout << s;
			    break;
			}
			/* cout << l->str << "=" << l->cval << "\n"; */
			  cout << l->cval << " ";
			}else printf("%s ",args_com[i]);
		    }// end for
		printf("\n");
		break;
	    }
	case EXIT:
	    {
		end = 1;
		break;
	    }
	case AT:
	    {
		int aa;
		memset(arithm_str, 0, sizeof(arithm_str));
		if (number_args == 0) {
		    PrintVars();
		} else {
		    for (aa = 0; aa <= number_args; aa++) {
			if (strncmp(args_com[aa], "$", 1) == 0) {
			    //cout<<"looked for:"<<args_com[aa];
			    l = FindVar(args_com[aa] + 1);
			    if (l != NULL) {
				strcat(arithm_str, l->cval);
			    } else {
				cout << "lidash: couldnt find that var\n";
				break;
			    }
			} else {
			    strcat(arithm_str, args_com[aa]);
			}
		    }
//                         cout<<"math:"<<arithm_str<<"\n";
		
		if( ASSIGN ) /*  */
		{
		char* s, *ss="";
		    if(s=(char*)strchr(arithm_str,'='))
		    {
		       *s++='\0';
		       AddVar( arithm_str, s? s:ss); /*   */
		    }
		    else fprintf(stderr,"lidash:   set  `='\n");
		    break;
		}
		    FILE *tmp_f;
		    arithm_tmp = tmpnam(NULL); /*     */
		    tmp_f = fopen(arithm_tmp, "w");
		    fprintf(tmp_f, "%s\n", arithm_str);
		    fclose(tmp_f);
		    arithm_main();
		}
		break;
	    }
	case OTHER:
	    {
		int bg = 0;
		/*  */
		char* s, *ss="";
		if( *path_com=='$' ) 
		    strncpy(path_com,FindVar(path_com+1)->cval,80);
		  if(s=(char*)strchr(path_com,'='))
		  {
		   *s++='\0';
		   AddVar( path_com, s? s:ss); //   
		   break;
		  }
		    
		if (strcmp(path_com, "") == 0)
		    break;
		if (strcmp(args_com[number_args], "&") == 0) {
		    bg = 1;
		    number_args--;
		}
		if (!(pid = fork()))	//child - process
		{
		    char *argv_[MAX_ARGS];
		    for (i = 1; i <= number_args; i++)	//formiruet argv_
		    {
			argv_[i] = (char *) malloc(strlen(args_com[i]));
			strcpy(argv_[i], args_com[i]);
		    }
		    argv_[0] = (char *) malloc(strlen(path_com));
		    strcpy(argv_[0], path_com);
		    argv_[number_args + 1] = NULL;
		    
		    if( bg ) setpgrp();	/*    */
		    
		    if (execvp(path_com, argv_) == -1)
			printf("%s:Bad name of file or error in command `%s'\n",
			       argv[0],path_com);
		    for (i = 0; i <= number_args + 1; i++) free(argv_[i]);
		    exit(0);
		}
		else		//parent - process
	    /*  */
		if( !bg ){
		    int ws;
		    char b[6];
		    waitpid( pid,&ws,WUNTRACED );
		    sprintf(b,"%i",WEXITSTATUS(ws));
		    AddVar("status",b);
		}
		break;
	    }
	}
	}
    return 0;
}


