%{
/* need this for the call to atof() below */
#include "tokens.h"
#include "calc.h"
#include "string.h"
int line=0;
char text[50];
char chr;

%}

%%

[0-9]+    {	
		yylval=atoi(yytext);
		return (DIGIT);
          }


[a-zA-Z]+ {       
         strcpy(text,yytext);
	 return (LETTER);
	}



\(	{ return(OS);
	}
\)	{ return(ZS);
	}
\+	{
	return(PLUS);
	}
\-	{ return(MINUS);
	}
\*	{ return(MUL);
	}
\/	{ return(DIV);
	}
\&	{ return(AND);
	}
\|	{ return(OR);
	}
\%	{ return(PROC);
	}
"\n"	{ return(NL);
	}
"="	{ return(ASS);
	}
"++"	{ return(INC);
	}
"--"	{ return(DEC);
	}
%%
int yywrap() {
return( 0 );
}
